/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main program body.
*******************************************************************************/

#include "debug.h"
#include "tx_api.h"

/* Global define */

/* Global Variable */

/*********************************************************************
 * @fn      GPIO_Toggle_INIT
 *
 * @brief   Initializes GPIOA.0
 *
 * @return  none
 */
void GPIO_Toggle_INIT(void)
{
	GPIO_InitTypeDef GPIO_InitStructure = {0};

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE, ENABLE);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOE, &GPIO_InitStructure);
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{

	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	// Delay_Init();
	USART_Printf_Init(115200);
	printf("SystemClk:%d\r\n", SystemCoreClock);

	// printf("GPIO Toggle TEST\r\n");
	GPIO_Toggle_INIT();

	// while (1)
	// {
	// 	Delay_Ms(250);
	// 	GPIO_WriteBit(GPIOE, GPIO_Pin_2, (i == 0) ? (i = Bit_SET) : (i = Bit_RESET));
	// }

	/* threadx 测试 */
	tx_kernel_enter();
}

static TX_THREAD thread_0;
static uint32_t stack[128];
static TX_THREAD thread_1;
static uint32_t stack_1[128];

void thread_0_entry(ULONG input)
{
	uint8_t i = 0;
	printf("thread 0");
	while (1)
	{
		GPIO_WriteBit(GPIOE, GPIO_Pin_2, (i == 0) ? (i = Bit_SET) : (i = Bit_RESET));
		for(volatile int i = 0; i < 1000000; i++)
		{
			asm("addi x1, x1, 0\n");
		}
	}
}
void thread_1_entry(ULONG input)
{
	printf("thread 1");
	while (1)
	{
		tx_thread_sleep(100);
	}
}

void tx_application_define(void *first_unused_memory)
{
	(void)first_unused_memory;
	tx_thread_create(&thread_0, "thread 0", thread_0_entry, 0, stack, sizeof(stack), 2, 2, TX_NO_TIME_SLICE, TX_AUTO_START);
	tx_thread_create(&thread_1, "thread 1", thread_1_entry, 0, stack_1, sizeof(stack_1), 1, 1, TX_NO_TIME_SLICE, TX_AUTO_START);
}
#define TICK_PER_SECOND 1000
/*********************************************************************
 * @fn      init_timer
 *
 * @brief   Initializes the systick
 *
 * @return  none
 */
void init_timer(void)
{
	NVIC_SetPriority(SysTicK_IRQn, 0xff);
	NVIC_EnableIRQ(SysTicK_IRQn);
	SysTick->CTLR = 0;
	SysTick->SR = 0;
	SysTick->CNT = 0;
	SysTick->CMP = SystemCoreClock / TICK_PER_SECOND;
	SysTick->CTLR = 0xf;
}

void clr_systick_sr(void)
{
	SysTick->SR = 0;
}
